Package com.tibco.patterns.qbp

## Class QueryDef

- java.lang.Object
- - com.tibco.patterns.qbp.QueryDef

- Direct Known Subclasses:
    `DateQueryDef`, `TextQueryDef`

      public class QueryDef
      extends java.lang.Object

  A definition of a query. Subclasses hold all parameters for creating a NetricsQuery object of a specific query type. Constructors take only required parameters. Other parameters are initially set to defaults (nulls) and can be assigned using setter methods. Constructors and setters must validate all parameters so that the object holds only valid parameters. All setters return this object for chaining of calls to setters.

- - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `QueryDef()` | Prevents direct instantiation.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.util.Optional<java.lang.String>` | `getGroupName()` |
    `java.util.Optional<java.lang.String>` | `getQueryName()` |
    `QueryDef` | `groupName​(java.lang.String value)` | Sets the group name of this querylet.
    `QueryDef` | `queryName​(java.lang.String value)` | Sets the name of this querylet.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### QueryDef

          protected QueryDef()

      Prevents direct instantiation.

  - ### Method Detail

    - #### queryName

          public QueryDef queryName​(java.lang.String value)

      Sets the name of this querylet. By default no name is used (null).
      Parameters:
        `value` - - the querylet name. If empty string, null is assigned.

    - #### getQueryName

          public java.util.Optional<java.lang.String> getQueryName()

      Returns:
        the name of this querylet, or empty Optional if no name. Never an empty string.

    - #### groupName

          public QueryDef groupName​(java.lang.String value)

      Sets the group name of this querylet. By default no group name is used (null).
      Parameters:
        `value` - the group name to set. If empty string, null is assigned.

    - #### getGroupName

          public java.util.Optional<java.lang.String> getGroupName()

      Returns:
        the group name of this querylet, or empty Optional if no name. Never an empty string.